package errortest.app;


import org.ffd2.solar.language.SpecificCommonErrorOutput;
import org.ffd2.solar.pretty.PrettyPrinter;

import errortest.austen.peg.base.ExpressionPeer;
import errortest.austen.peg.base.StatementPeer;
import errortest.austen.peg.base.StatementPeer.IfPatternPeer;
import errortest.austen.peg.base.StatementPeer.Indirect;

public class IfStatement implements StatementHandler, IfPatternPeer {
	private final StatementsBlock trueStatements_;
	private StatementsBlock falseStatementsMaybeNull_;

	private final ExpressionBlock conditional_;
	private final SpecificCommonErrorOutput error_;
	public IfStatement(SpecificCommonErrorOutput error) {
		this.error_ = error;
		this.trueStatements_ = new StatementsBlock(error);
		this.conditional_ = new ExpressionBlock();
	}

	public void output(PrettyPrinter pp) {
		pp.print("if(");
			this.conditional_.output(pp);
		pp.print(")").increaseIndent().newLine();
			this.trueStatements_.output(pp);
		pp.decreaseIndent();
		//Check if we have an else block
		if(this.falseStatementsMaybeNull_!=null ) {
			pp.print(" else ").increaseIndent().newLine();
				this.falseStatementsMaybeNull_.output(pp);
			pp.decreaseIndent();
		}
	}

	public void end() { }

	public ExpressionPeer.Indirect getExpressionForConditional() { return this.conditional_; }


	public StatementPeer.Indirect getStatementForTrueStatement() { return this.trueStatements_; }

	public StatementPeer.Indirect getStatementForFalseStatement() {
		return this.falseStatementsMaybeNull_ = new StatementsBlock(this.error_);
	}
}
