package errortest.austen.packrat.impl;
import errortest.austen.packrat.library.*;
import errortest.austen.lexi.tokens.*;
public final class ExpressionReader implements ErrorTestPackrat.BaseReader {
	private final int rULE_INDEX_ = 0;
	private final ErrorTestPackrat basePackrat_;
	public ExpressionReader(ErrorTestPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(ErrorTestPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = 0;
		result.mark();
		width = decodeAdditionForExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 0, 0);
			width = result.endRestrain(0, 1);
			return oldElement.getImprovedByOrNull(result, 1);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeSubtractionForExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 1, 0);
			width = result.endRestrain(0, 1);
			return oldElement.getImprovedByOrNull(result, 1);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeMultiplicationForExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 2, 0);
			width = result.endRestrain(0, 3);
			return oldElement.getImprovedByOrNull(result, 3);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeDivisionForExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 3, 0);
			width = result.endRestrain(0, 3);
			return oldElement.getImprovedByOrNull(result, 3);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeFunctionForExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 4, 0);
			width = result.endRestrain(0, 4);
			return oldElement.getImprovedByOrNull(result, 4);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeVariableForExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 5, 0);
			width = result.endRestrain(0, 5);
			return oldElement.getImprovedByOrNull(result, 5);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodePrimitiveForExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 6, 0);
			width = result.endRestrain(0, 6);
			return oldElement.getImprovedByOrNull(result, 6);
		} else {
			result.undoToMark();
		}
		return null;
	}
	public final int decodeAdditionForExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 0).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isPLUS_SYMBOL()) {
			return -1;
		}
		result.addSubToken(-1, token);
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule_1 = c.getResult(newOffset, 0).getResolved();
		if(rule_1 == null) {
			return -1;
		}
		newOffset += rule_1.getWidth();
		result.addSubNode(1, rule_1);
		return newOffset;
	}
	public final int decodeSubtractionForExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 0).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isMINUS_SYMBOL()) {
			return -1;
		}
		result.addSubToken(-1, token);
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule_1 = c.getResult(newOffset, 0).getResolved();
		if(rule_1 == null) {
			return -1;
		}
		newOffset += rule_1.getWidth();
		result.addSubNode(1, rule_1);
		return newOffset;
	}
	public final int decodeMultiplicationForExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 0).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isSTAR_SYMBOL()) {
			return -1;
		}
		result.addSubToken(-1, token);
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule_1 = c.getResult(newOffset, 0).getResolved();
		if(rule_1 == null) {
			return -1;
		}
		newOffset += rule_1.getWidth();
		result.addSubNode(1, rule_1);
		return newOffset;
	}
	public final int decodeDivisionForExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 0).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isSLASH_SYMBOL()) {
			return -1;
		}
		result.addSubToken(-1, token);
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule_1 = c.getResult(newOffset, 0).getResolved();
		if(rule_1 == null) {
			return -1;
		}
		newOffset += rule_1.getWidth();
		result.addSubNode(1, rule_1);
		return newOffset;
	}
	public final int decodeFunctionForExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		ErrorsToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isLEFT_ROUND()) {
			return -1;
		}
		result.addSubToken(-1, token_1);
		newOffset++;
		result.mark();
		int checkOffset = maybeSub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		c.setErrorHint("Expecting closing round bracket", newOffset);
		ErrorsToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isRIGHT_ROUND()) {
			return -1;
		}
		result.addSubToken(-1, token_2);
		newOffset++;
		return newOffset;
	}
	public final int maybeSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		result.mark();
		int checkOffset = dividedPrimarySub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
			return -1;
		} else {
			newOffset = checkOffset;
			result.bumpLastMark();
			while(checkOffset > 0) {
				checkOffset = dividedSecondarySub(result, c, newOffset);
				if(checkOffset >= 0) {
					checkOffset = dividedPrimarySub(result, c, checkOffset);
				}
				if(checkOffset >= 0) {
					newOffset = checkOffset;
					result.bumpLastMark();
				} else {
					result.undoToMark();
				}
			}
		}
		return newOffset;
	}
	public final int dividedPrimarySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 0).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int dividedSecondarySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isCOMMA_SYMBOL()) {
			return -1;
		}
		result.addSubToken(-1, token);
		newOffset++;
		c.setErrorHint("Expecting expression", newOffset);
		return newOffset;
	}
	public final int decodeVariableForExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		return newOffset;
	}
	public final int decodePrimitiveForExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset = itemSub(result, c, newOffset);
			if(checkOffset < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub_3(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		return newOffset;
	}
	public final int itemSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset = itemSub_1(result, c, newOffset);
			if(checkOffset < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub_2(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		return newOffset;
	}
	public final int itemSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isNUMBER()) {
			return -1;
		}
		result.addSubToken(0, token);
		newOffset++;
		return newOffset;
	}
	public final int itemSub_2(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isBOOLEAN()) {
			return -1;
		}
		result.addSubToken(1, token);
		newOffset++;
		return newOffset;
	}
	public final int itemSub_3(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isSTRING()) {
			return -1;
		}
		result.addSubToken(2, token);
		newOffset++;
		return newOffset;
	}
}
