package errortest.austen.packrat.impl;
import errortest.austen.packrat.library.*;
import errortest.austen.lexi.tokens.*;
public final class StatementReader implements ErrorTestPackrat.BaseReader {
	private final int rULE_INDEX_ = 1;
	private final ErrorTestPackrat basePackrat_;
	public StatementReader(ErrorTestPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(ErrorTestPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = 0;
		result.mark();
		width = decodeAssignmentForStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 0, 1);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeBlockForStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 1, 1);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeIfForStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 2, 1);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeExpressionForStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 3, 1);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeErrorForStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 4, 1);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		return null;
	}
	public final int decodeAssignmentForStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		ErrorsToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isASSIGNMENT_SYMBOL()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 0).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		ErrorsToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int decodeBlockForStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isLEFT_CURLY()) {
			return -1;
		}
		newOffset++;
		int checkOffset = newOffset;
		result.mark();
		while(checkOffset >= 0) {
			checkOffset = zeroOrMoreSub(result, c, newOffset);
			if(checkOffset > newOffset) {
				newOffset = checkOffset;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		ErrorsToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isRIGHT_CURLY()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int zeroOrMoreSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 1).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int decodeIfForStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isIF_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		ErrorsToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isLEFT_ROUND()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 0).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		ErrorsToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isRIGHT_ROUND()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule_1 = c.getResult(newOffset, 1).getResolved();
		if(rule_1 == null) {
			return -1;
		}
		newOffset += rule_1.getWidth();
		result.addSubNode(1, rule_1);
		result.mark();
		int checkOffset = maybeSub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		return newOffset;
	}
	public final int maybeSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isELSE_KEYWORD()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 1).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(2, rule);
		return newOffset;
	}
	public final int decodeExpressionForStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 0).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int decodeErrorForStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		result.mark();
		int checkOffset = notFollowedBySub(result, c, newOffset);
		result.undoToMark();
		if(checkOffset > 0) {
			return -1;
		}
		result.addPositionMark(0, c.getColumnTokenOrLast(newOffset), true);
		result.mark();
		int checkOffset_1 = oneOrMoreSub(result, c, newOffset);
		if(checkOffset_1 < 0) {
			result.undoToMark();
			return -1;
		} else {
			newOffset = checkOffset_1;
			result.bumpLastMark();
			while(checkOffset_1 >= 0) {
				checkOffset_1 = oneOrMoreSub(result, c, newOffset);
				if(checkOffset_1 > newOffset) {
					newOffset = checkOffset_1;
					result.bumpLastMark();
				} else {
					result.undoToMark();
				}
			}
		}
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		return newOffset;
	}
	public final int notFollowedBySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isRIGHT_CURLY()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int oneOrMoreSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		result.mark();
		int checkOffset = notFollowedBySub_1(result, c, newOffset);
		result.undoToMark();
		if(checkOffset > 0) {
			return -1;
		}
		if(!c.isColumnTokenAt(newOffset)) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int notFollowedBySub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
}
