package indent.app;

import indent.austen.peg.base.ClassPatternPeer;
import indent.austen.peg.base.ClassElementPeer.FunctionDefPatternPeer;

import org.ffd2.solar.pretty.PrettyPrinter;

public final class ClassBlock implements ClassPatternPeer {
	private final String className_;
	private  FunctionBlock lastFunction_ = null;
	private final ClassBlock previousClass_;
	public ClassBlock(String className, ClassBlock previousClass) {
		this.className_ = className;
		this.previousClass_ = previousClass;
		
	}
	public void output(PrettyPrinter pp) {
		if(this.previousClass_!=null) {
			this.previousClass_.output(pp);
			pp.newLine();
		}
		pp.print("class ").print(className_).print(" {").increaseIndent().newLine();
			if(this.lastFunction_!=null) {
				this.lastFunction_.output(pp);
			}
		pp.newLine().decreaseIndent().print("}");
	}
	public void end() { }

	public FunctionDefPatternPeer addOptionFunctionDefOfClassElementForElements(int keywordLine, int keywordCharacter, String name) {
		return this.lastFunction_ = new FunctionBlock(name,this.lastFunction_);
	}
	
}