package indent.app;

import indent.austen.peg.base.StatementPeer;
import indent.austen.peg.base.ClassElementPeer.FunctionDefPatternPeer;

import org.ffd2.solar.general.SimpleVector;
import org.ffd2.solar.pretty.PrettyPrinter;

public final class FunctionBlock implements FunctionDefPatternPeer {
	private final SimpleVector<String> parameterNames_ = new SimpleVector<String>();
	private final String functionName_;
	private final FunctionBlock previousFunction_;
	private final StatementsBlock statements_;
	public FunctionBlock(String functionName, FunctionBlock previousFunction) {
		this.functionName_ = functionName;
		this.previousFunction_ = previousFunction;
		this.statements_ = new StatementsBlock();
	}

	public void end() { }

	public void addP(String value) {
		this.parameterNames_.addElement(value);
	}

	public StatementPeer.Indirect getStatementForStatements() {
		return this.statements_;
	}
	public void output(PrettyPrinter pp) {
		if(this.previousFunction_!=null) {
			this.previousFunction_.output(pp);
			pp.newLine();
		}
		pp.print("function ").print(this.functionName_).print("(").print(this.parameterNames_.toString(", ")).print(") {").increaseIndent().newLine();
			this.statements_.output(pp);
		pp.newLine().decreaseIndent().print("}");
	}
}