package indent.app;

import indent.austen.peg.base.ExpressionPeer;
import indent.austen.peg.base.StatementPeer;
import indent.austen.peg.base.StatementPeer.IfPatternPeer;
import indent.austen.peg.base.StatementPeer.Indirect;

import org.ffd2.solar.pretty.PrettyPrinter;

public final class IfStatement implements StatementHandler,IfPatternPeer {
	private final StatementsBlock statements_;
	private StatementsBlock elseStatementsMaybeNull_;

	private final ExpressionBlock conditional_;
	public IfStatement() {
		this.statements_ = new StatementsBlock();
		this.conditional_ = new ExpressionBlock();
	}

	public void output(PrettyPrinter pp) {
		pp.print("if(");
			this.conditional_.output(pp);
		pp.print(") {").increaseIndent().newLine();
			this.statements_.output(pp);
		pp.newLine().decreaseIndent().print("}");
		//Check if we have an else block
		if(this.elseStatementsMaybeNull_!=null ) {
			pp.print(" else {").increaseIndent().newLine();
				this.elseStatementsMaybeNull_.output(pp);
			pp.newLine().decreaseIndent().print("}");
		}
	}

	public void end() { }

	public ExpressionPeer.Indirect getExpressionForConditional() { return this.conditional_; }

	public StatementPeer.Indirect getStatementForStatements() {
		return this.statements_;
	}

	public StatementPeer.Indirect getStatementForElseStatements() {
		//This is called multiple time for each statements - we create the block where they are all stored the first
		//time we get an else statement
		if(this.elseStatementsMaybeNull_==null ) {
			this.elseStatementsMaybeNull_ = new StatementsBlock();
		}
		return this.elseStatementsMaybeNull_;
	}
}