package indent.app;

import org.ffd2.solar.general.Debug;

import indent.austen.user.IndentTrackerUser;

public class IndentTracker implements IndentTrackerUser {
	private int[] indentCounts_;
	private int currentLine_;
	private final int bufferIncrease_;
	private final int tabSize_;
	public IndentTracker(int bufferIncrease, int tabSize) {
		this.bufferIncrease_ = bufferIncrease;
		this.tabSize_ = tabSize;
		this.indentCounts_ = new int[bufferIncrease];
	}
	public void dumpIndents() {
		for(int i = 0 ; i < currentLine_ ; i++ ) {
			System.out.println(i+":"+this.indentCounts_[i]);
		}
	}
	public int getIndent(int line) {
		return indentCounts_[line-1];
	}
	public void newLine() {
		currentLine_++;
		if(currentLine_>=indentCounts_.length) {
			int[] old = indentCounts_;
			this.indentCounts_ = new int[old.length+bufferIncrease_];
			System.arraycopy(old,0,indentCounts_,0,old.length);
		}
		indentCounts_[currentLine_] = 0; //I know not needed but I like things initialised
	}
	
	public void newWhitespace(String whitespace, int cursorCharacter) {
		if(cursorCharacter==1) {
			int count = 0;
			for(int i = whitespace.length()-1 ; i>=0 ; i--) {
				if(whitespace.charAt(i)=='\t') {
					count+=this.tabSize_;
				} else {
					count++;
				}
			}
			indentCounts_[currentLine_] = count;
		}
	}
}
