package indent.app;

import indent.austen.peg.base.StatementPeer;
import indent.austen.peg.base.StatementPeer.AssignmentPatternPeer;
import indent.austen.peg.base.StatementPeer.ExpressionPatternPeer;
import indent.austen.peg.base.StatementPeer.IfPatternPeer;

import org.ffd2.solar.general.SimpleVector;
import org.ffd2.solar.pretty.PrettyPrinter;

public final class StatementsBlock implements StatementPeer.Indirect {
	private final SimpleVector<StatementHandler> statements_ = new SimpleVector<StatementHandler>();
	/**
	 * Output, but don't include a final new line
	 * @param pp
	 */
	public void output(PrettyPrinter pp) {
		boolean addNewline = false;
		//Don't include an end newline...
		for(StatementHandler statement : statements_ ) {
			if(addNewline) {
				pp.newLine();
			} else {
				addNewline = true;
			}
			statement.output(pp);
		}
	}

	public AssignmentPatternPeer createAssignment(String variable) {
		AssignmentStatement statement = new AssignmentStatement(variable);
		this.statements_.addElement(statement);
		return statement;
	}

	public ExpressionPatternPeer createExpression() {
		ExpressionStatement statement = new ExpressionStatement();
		this.statements_.addElement(statement);
		return statement;
	}

	public IfPatternPeer createIf(int keywordLine, int keywordCharacter) {
		IfStatement statement = new IfStatement();
		this.statements_.addElement(statement);
		return statement;
	}
	
}