package indent.austen.lexi.tokens;
public final class TestTable implements TestUser {
	private final org.ffd2.solar.general.SimpleVector<IndentToken> tableStore_;
	private final int[] marks_;
	public TestTable() {
		tableStore_ = new org.ffd2.solar.general.SimpleVector<IndentToken>();
		marks_ = new int[0];
	}
	public TestTable(org.ffd2.solar.general.SimpleVector<IndentToken> target) {
		tableStore_ = target;
		marks_ = new int[0];
	}
	public final void markToken(int markIndex) {
		marks_[markIndex] = tableStore_.size();
	}
	public final void reverseTokens(int startToken) {
		tableStore_.reverseOrderOfElements(startToken);
	}
	public final int getMarkToken(int markIndex) {
		return marks_[markIndex];
	}
	public final org.ffd2.solar.general.SimpleVector<IndentToken> getTokens() {
		return tableStore_;
	}
	public final java.lang.String toString() {
		return "Test" + " token table for " + "Indent" + " " + tableStore_;
	}
	public final void reset() {
		tableStore_.removeAllElements();
	}
	public final void tokenAT_SYMBOL(int lineNumber, int characterNumber) {
		TestTable.AT_SYMBOLTokenImpl token = new TestTable.AT_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenFULL_STOP_SYMBOL(int lineNumber, int characterNumber) {
		TestTable.FULL_STOP_SYMBOLTokenImpl token = new TestTable.FULL_STOP_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenLEFT_CURLY(int lineNumber, int characterNumber) {
		TestTable.LEFT_CURLYTokenImpl token = new TestTable.LEFT_CURLYTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenRIGHT_CURLY(int lineNumber, int characterNumber) {
		TestTable.RIGHT_CURLYTokenImpl token = new TestTable.RIGHT_CURLYTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenLEFT_ROUND(int lineNumber, int characterNumber) {
		TestTable.LEFT_ROUNDTokenImpl token = new TestTable.LEFT_ROUNDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenRIGHT_ROUND(int lineNumber, int characterNumber) {
		TestTable.RIGHT_ROUNDTokenImpl token = new TestTable.RIGHT_ROUNDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenSEMI_COLON_SYMBOL(int lineNumber, int characterNumber) {
		TestTable.SEMI_COLON_SYMBOLTokenImpl token = new TestTable.SEMI_COLON_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenCOLON(int lineNumber, int characterNumber) {
		TestTable.COLONTokenImpl token = new TestTable.COLONTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenOR_SYMBOL(int lineNumber, int characterNumber) {
		TestTable.OR_SYMBOLTokenImpl token = new TestTable.OR_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenMINUS_SYMBOL(int lineNumber, int characterNumber) {
		TestTable.MINUS_SYMBOLTokenImpl token = new TestTable.MINUS_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenDOLLAR_SYMBOL(int lineNumber, int characterNumber) {
		TestTable.DOLLAR_SYMBOLTokenImpl token = new TestTable.DOLLAR_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenCOMMA_SYMBOL(int lineNumber, int characterNumber) {
		TestTable.COMMA_SYMBOLTokenImpl token = new TestTable.COMMA_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenQUESTION_MARK_SYMBOL(int lineNumber, int characterNumber) {
		TestTable.QUESTION_MARK_SYMBOLTokenImpl token = new TestTable.QUESTION_MARK_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenASSIGNMENT_SYMBOL(int lineNumber, int characterNumber) {
		TestTable.ASSIGNMENT_SYMBOLTokenImpl token = new TestTable.ASSIGNMENT_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenPLUS_SYMBOL(int lineNumber, int characterNumber) {
		TestTable.PLUS_SYMBOLTokenImpl token = new TestTable.PLUS_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenSTAR_SYMBOL(int lineNumber, int characterNumber) {
		TestTable.STAR_SYMBOLTokenImpl token = new TestTable.STAR_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenSLASH_SYMBOL(int lineNumber, int characterNumber) {
		TestTable.SLASH_SYMBOLTokenImpl token = new TestTable.SLASH_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenESCAPE_SYMBOL(int lineNumber, int characterNumber) {
		TestTable.ESCAPE_SYMBOLTokenImpl token = new TestTable.ESCAPE_SYMBOLTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenBOOLEAN(boolean value, int lineNumber, int characterNumber) {
		TestTable.BOOLEANTokenImpl token = new TestTable.BOOLEANTokenImpl(value, lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenBOOLEAN_1(boolean value, int lineNumber, int characterNumber) {
		TestTable.BOOLEANTokenImpl_1 token = new TestTable.BOOLEANTokenImpl_1(value, lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenFUNCTION_KEYWORD(int lineNumber, int characterNumber) {
		TestTable.FUNCTION_KEYWORDTokenImpl token = new TestTable.FUNCTION_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenFUNCTION_KEYWORD_1(int lineNumber, int characterNumber) {
		TestTable.FUNCTION_KEYWORDTokenImpl_1 token = new TestTable.FUNCTION_KEYWORDTokenImpl_1(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenCLASS_KEYWORD(int lineNumber, int characterNumber) {
		TestTable.CLASS_KEYWORDTokenImpl token = new TestTable.CLASS_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenIF_KEYWORD(int lineNumber, int characterNumber) {
		TestTable.IF_KEYWORDTokenImpl token = new TestTable.IF_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenELSE_KEYWORD(int lineNumber, int characterNumber) {
		TestTable.ELSE_KEYWORDTokenImpl token = new TestTable.ELSE_KEYWORDTokenImpl(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenSTRING(java.lang.String value, int lineNumber, int characterNumber) {
		TestTable.STRINGTokenImpl token = new TestTable.STRINGTokenImpl(value, lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenID(java.lang.String value, int lineNumber, int characterNumber) {
		TestTable.IDTokenImpl token = new TestTable.IDTokenImpl(value, lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenNUMBER(int value, int lineNumber, int characterNumber) {
		TestTable.NUMBERTokenImpl token = new TestTable.NUMBERTokenImpl(value, lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenNUMBER_1(int value, int lineNumber, int characterNumber) {
		TestTable.NUMBERTokenImpl_1 token = new TestTable.NUMBERTokenImpl_1(value, lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public final void tokenASSIGNMENT_SYMBOL_1(int lineNumber, int characterNumber) {
		TestTable.ASSIGNMENT_SYMBOLTokenImpl_1 token = new TestTable.ASSIGNMENT_SYMBOLTokenImpl_1(lineNumber, characterNumber);
		tableStore_.addElement(token);
	}
	public static final class AT_SYMBOLTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public AT_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "@";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "AT_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return true;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class FULL_STOP_SYMBOLTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public FULL_STOP_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return ".";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "FULL_STOP_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return true;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class LEFT_CURLYTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public LEFT_CURLYTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "{";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "LEFT_CURLY" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return true;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class RIGHT_CURLYTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public RIGHT_CURLYTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "}";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "RIGHT_CURLY" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return true;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class LEFT_ROUNDTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public LEFT_ROUNDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "(";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "LEFT_ROUND" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return true;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class RIGHT_ROUNDTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public RIGHT_ROUNDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return ")";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "RIGHT_ROUND" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return true;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class SEMI_COLON_SYMBOLTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public SEMI_COLON_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return ";";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "SEMI_COLON_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return true;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class COLONTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public COLONTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return ":";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "COLON" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return true;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class OR_SYMBOLTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public OR_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "|";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "OR_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return true;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class MINUS_SYMBOLTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public MINUS_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "-";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "MINUS_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return true;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class DOLLAR_SYMBOLTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public DOLLAR_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "$";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "DOLLAR_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return true;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class COMMA_SYMBOLTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public COMMA_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return ",";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "COMMA_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return true;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class QUESTION_MARK_SYMBOLTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public QUESTION_MARK_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "?";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "QUESTION_MARK_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return true;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class ASSIGNMENT_SYMBOLTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public ASSIGNMENT_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "=";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "ASSIGNMENT_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return true;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class PLUS_SYMBOLTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public PLUS_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "PLUS_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return true;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class STAR_SYMBOLTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public STAR_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "STAR_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return true;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class SLASH_SYMBOLTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public SLASH_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "SLASH_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return true;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class ESCAPE_SYMBOLTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public ESCAPE_SYMBOLTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "ESCAPE_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return true;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class BOOLEANTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		private final boolean value_;
		public BOOLEANTokenImpl(boolean value, int lineNumber, int characterNumber) {
			value_ = value;
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			if(value_) {
				return 1;
			} else {
				return 0;
			}
		}
		public final long getLongValue() {
			if(value_) {
				return 1;
			} else {
				return 0;
			}
		}
		public final java.lang.String getStringValue() {
			return java.lang.String.valueOf(value_);
		}
		public final boolean getBooleanValue() {
			return value_;
		}
		public final double getDoubleValue() {
			if(value_) {
				return 1;
			} else {
				return 0;
			}
		}
		public final java.lang.String toString() {
			return "BOOLEAN" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return true;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class BOOLEANTokenImpl_1 implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		private final boolean value_;
		public BOOLEANTokenImpl_1(boolean value, int lineNumber, int characterNumber) {
			value_ = value;
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			if(value_) {
				return 1;
			} else {
				return 0;
			}
		}
		public final long getLongValue() {
			if(value_) {
				return 1;
			} else {
				return 0;
			}
		}
		public final java.lang.String getStringValue() {
			return java.lang.String.valueOf(value_);
		}
		public final boolean getBooleanValue() {
			return value_;
		}
		public final double getDoubleValue() {
			if(value_) {
				return 1;
			} else {
				return 0;
			}
		}
		public final java.lang.String toString() {
			return "BOOLEAN" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return true;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class FUNCTION_KEYWORDTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public FUNCTION_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "function";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "FUNCTION_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return true;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return true;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class FUNCTION_KEYWORDTokenImpl_1 implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public FUNCTION_KEYWORDTokenImpl_1(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "fn";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "FUNCTION_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return true;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return true;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class CLASS_KEYWORDTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public CLASS_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "class";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "CLASS_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return true;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return true;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class IF_KEYWORDTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public IF_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "if";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "IF_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return true;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return true;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class ELSE_KEYWORDTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public ELSE_KEYWORDTokenImpl(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "else";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "ELSE_KEYWORD" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return true;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return true;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class STRINGTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		private final java.lang.String value_;
		public STRINGTokenImpl(java.lang.String value, int lineNumber, int characterNumber) {
			value_ = value;
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return value_;
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "STRING" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return true;
		}
	}
	public static final class IDTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		private final java.lang.String value_;
		public IDTokenImpl(java.lang.String value, int lineNumber, int characterNumber) {
			value_ = value;
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return value_;
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "ID" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return true;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class NUMBERTokenImpl implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		private final int value_;
		public NUMBERTokenImpl(int value, int lineNumber, int characterNumber) {
			value_ = value;
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return value_;
		}
		public final long getLongValue() {
			return value_;
		}
		public final java.lang.String getStringValue() {
			return java.lang.String.valueOf(value_);
		}
		public final boolean getBooleanValue() {
			return value_ > 0;
		}
		public final double getDoubleValue() {
			return value_;
		}
		public final java.lang.String toString() {
			return "NUMBER" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return true;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class NUMBERTokenImpl_1 implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		private final int value_;
		public NUMBERTokenImpl_1(int value, int lineNumber, int characterNumber) {
			value_ = value;
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return value_;
		}
		public final long getLongValue() {
			return value_;
		}
		public final java.lang.String getStringValue() {
			return java.lang.String.valueOf(value_);
		}
		public final boolean getBooleanValue() {
			return value_ > 0;
		}
		public final double getDoubleValue() {
			return value_;
		}
		public final java.lang.String toString() {
			return "NUMBER" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return true;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
	public static final class ASSIGNMENT_SYMBOLTokenImpl_1 implements IndentToken {
		private final int lineNumber_;
		private final int characterNumber_;
		public ASSIGNMENT_SYMBOLTokenImpl_1(int lineNumber, int characterNumber) {
			lineNumber_ = lineNumber;
			characterNumber_ = characterNumber;
		}
		public final int getLineNumber() {
			return lineNumber_;
		}
		public final int getCharacterNumber() {
			return characterNumber_;
		}
		public final org.ffd2.austenx.runtime.BaseToken[] getArrayElements() {
			return null;
		}
		public final int getIntValue() {
			return 0;
		}
		public final long getLongValue() {
			return 0;
		}
		public final java.lang.String getStringValue() {
			return "void";
		}
		public final boolean getBooleanValue() {
			return false;
		}
		public final double getDoubleValue() {
			return 0;
		}
		public final java.lang.String toString() {
			return "ASSIGNMENT_SYMBOL" + " line " + lineNumber_ + "  " + characterNumber_;
		}
		public final boolean isSLASH_SYMBOL() {
			return false;
		}
		public final boolean isEXCLAMATION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isOR_SYMBOL() {
			return false;
		}
		public final boolean isRIGHT_CURLY() {
			return false;
		}
		public final boolean isMINUS_SYMBOL() {
			return false;
		}
		public final boolean isPLUS_SYMBOL() {
			return false;
		}
		public final boolean isAMPERSAND_SYMBOL() {
			return false;
		}
		public final boolean isESCAPE_SYMBOL() {
			return false;
		}
		public final boolean isNUMBER() {
			return false;
		}
		public final boolean isAT_SYMBOL() {
			return false;
		}
		public final boolean isCLASS_KEYWORD() {
			return false;
		}
		public final boolean isSTAR_SYMBOL() {
			return false;
		}
		public final boolean isSEMI_COLON_SYMBOL() {
			return false;
		}
		public final boolean isID() {
			return false;
		}
		public final boolean isCOMMA_SYMBOL() {
			return false;
		}
		public final boolean isCOLON() {
			return false;
		}
		public final boolean isBOOLEAN() {
			return false;
		}
		public final boolean isELSE_KEYWORD() {
			return false;
		}
		public final boolean isRIGHT_ROUND() {
			return false;
		}
		public final boolean isFULL_STOP_SYMBOL() {
			return false;
		}
		public final boolean isLEFT_CURLY() {
			return false;
		}
		public final boolean isASSIGNMENT_SYMBOL() {
			return true;
		}
		public final boolean isLEFT_ROUND() {
			return false;
		}
		public final boolean isDOLLAR_SYMBOL() {
			return false;
		}
		public final boolean isQUESTION_MARK_SYMBOL() {
			return false;
		}
		public final boolean isFUNCTION_KEYWORD() {
			return false;
		}
		public final boolean isIF_KEYWORD() {
			return false;
		}
		public final boolean isSTRING() {
			return false;
		}
	}
}
