package indent.austen.packrat.impl;
import indent.austen.peg.base.*;
public final class AllDecodersIndentTest {
	public static final class FunctionDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ExpressionPeer.FunctionPatternPeer peer_;
		public FunctionDecoder(ExpressionPeer.FunctionPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					ExpressionPeer.Indirect indirect = peer_.getExpressionForValue();
					if(indirect != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
						ExpressionPeer.FunctionPatternPeer child = indirect.createFunction(nameToken.getStringValue());
						if(child != null) {
							element.updateConstruction(new AllDecodersIndentTest.FunctionDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					ExpressionPeer.Indirect indirect_1 = peer_.getExpressionForValue();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(0);
						indirect_1.createVariable(nameToken_1.getStringValue());
					}
				}
				if(type == 2) {
					ExpressionPeer.Indirect indirect_2 = peer_.getExpressionForValue();
					if(indirect_2 != null) {
						ExpressionPeer.PrimitivePatternPeer child_1 = indirect_2.createPrimitive();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersIndentTest.PrimitiveDecoder(child_1));
							child_1.end();
						}
					}
				}
			}
		}
	}
	public static final class PrimitiveDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ExpressionPeer.PrimitivePatternPeer peer_;
		public PrimitiveDecoder(ExpressionPeer.PrimitivePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addNumber(token.getIntValue());
			}
			if(index == 1) {
				peer_.addBool(token.getBooleanValue());
			}
			if(index == 2) {
				peer_.addString(token.getStringValue());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
		}
	}
	public static final class FileDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final FilePatternPeer peer_;
		public FileDecoder(FilePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
				org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(1);
				ClassPatternPeer child = peer_.addClassForClassBlock(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), nameToken.getStringValue());
				if(child != null) {
					element.updateConstruction(new AllDecodersIndentTest.ClassDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class ClassDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ClassPatternPeer peer_;
		public ClassDecoder(ClassPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(1);
					ClassElementPeer.FunctionDefPatternPeer child = peer_.addOptionFunctionDefOfClassElementForElements(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), nameToken.getStringValue());
					if(child != null) {
						element.updateConstruction(new AllDecodersIndentTest.FunctionDefDecoder(child));
						child.end();
					}
				}
			}
		}
	}
	public static final class ClassStrictDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ClassStrictPatternPeer peer_;
		public ClassStrictDecoder(ClassStrictPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
					org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(1);
					ClassElementPeer.FunctionDefPatternPeer child = peer_.addOptionFunctionDefOfClassElementForElements(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), nameToken.getStringValue());
					if(child != null) {
						element.updateConstruction(new AllDecodersIndentTest.FunctionDefDecoder(child));
						child.end();
					}
				}
			}
		}
	}
	public static final class FunctionDefDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ClassElementPeer.FunctionDefPatternPeer peer_;
		public FunctionDefDecoder(ClassElementPeer.FunctionDefPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 2) {
				peer_.addP(token.getStringValue());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					StatementPeer.Indirect indirect = peer_.getStatementForStatements();
					if(indirect != null) {
						org.ffd2.austenx.runtime.BaseToken variableToken = element.getBaseArgumentToken(0);
						StatementPeer.AssignmentPatternPeer child = indirect.createAssignment(variableToken.getStringValue());
						if(child != null) {
							element.updateConstruction(new AllDecodersIndentTest.AssignmentDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					StatementPeer.Indirect indirect_1 = peer_.getStatementForStatements();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						StatementPeer.IfPatternPeer child_1 = indirect_1.createIf(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersIndentTest.IfDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					StatementPeer.Indirect indirect_2 = peer_.getStatementForStatements();
					if(indirect_2 != null) {
						StatementPeer.ExpressionPatternPeer child_2 = indirect_2.createExpression();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersIndentTest.ExpressionDecoder(child_2));
							child_2.end();
						}
					}
				}
			}
		}
	}
	public static final class AssignmentDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final StatementPeer.AssignmentPatternPeer peer_;
		public AssignmentDecoder(StatementPeer.AssignmentPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					ExpressionPeer.Indirect indirect = peer_.getExpressionForValue();
					if(indirect != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
						ExpressionPeer.FunctionPatternPeer child = indirect.createFunction(nameToken.getStringValue());
						if(child != null) {
							element.updateConstruction(new AllDecodersIndentTest.FunctionDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					ExpressionPeer.Indirect indirect_1 = peer_.getExpressionForValue();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(0);
						indirect_1.createVariable(nameToken_1.getStringValue());
					}
				}
				if(type == 2) {
					ExpressionPeer.Indirect indirect_2 = peer_.getExpressionForValue();
					if(indirect_2 != null) {
						ExpressionPeer.PrimitivePatternPeer child_1 = indirect_2.createPrimitive();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersIndentTest.PrimitiveDecoder(child_1));
							child_1.end();
						}
					}
				}
			}
		}
	}
	public static final class IfDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final StatementPeer.IfPatternPeer peer_;
		public IfDecoder(StatementPeer.IfPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					ExpressionPeer.Indirect indirect = peer_.getExpressionForConditional();
					if(indirect != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
						ExpressionPeer.FunctionPatternPeer child = indirect.createFunction(nameToken.getStringValue());
						if(child != null) {
							element.updateConstruction(new AllDecodersIndentTest.FunctionDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					ExpressionPeer.Indirect indirect_1 = peer_.getExpressionForConditional();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(0);
						indirect_1.createVariable(nameToken_1.getStringValue());
					}
				}
				if(type == 2) {
					ExpressionPeer.Indirect indirect_2 = peer_.getExpressionForConditional();
					if(indirect_2 != null) {
						ExpressionPeer.PrimitivePatternPeer child_1 = indirect_2.createPrimitive();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersIndentTest.PrimitiveDecoder(child_1));
							child_1.end();
						}
					}
				}
			}
			if(index == 1) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					StatementPeer.Indirect indirect_3 = peer_.getStatementForStatements();
					if(indirect_3 != null) {
						org.ffd2.austenx.runtime.BaseToken variableToken = element.getBaseArgumentToken(0);
						StatementPeer.AssignmentPatternPeer child_2 = indirect_3.createAssignment(variableToken.getStringValue());
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersIndentTest.AssignmentDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type_1 == 1) {
					StatementPeer.Indirect indirect_4 = peer_.getStatementForStatements();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						StatementPeer.IfPatternPeer child_3 = indirect_4.createIf(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersIndentTest.IfDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type_1 == 2) {
					StatementPeer.Indirect indirect_5 = peer_.getStatementForStatements();
					if(indirect_5 != null) {
						StatementPeer.ExpressionPatternPeer child_4 = indirect_5.createExpression();
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersIndentTest.ExpressionDecoder(child_4));
							child_4.end();
						}
					}
				}
			}
			if(index == 2) {
				int type_2 = element.getType();
				if(type_2 == 0) {
					StatementPeer.Indirect indirect_6 = peer_.getStatementForElseStatements();
					if(indirect_6 != null) {
						org.ffd2.austenx.runtime.BaseToken variableToken_1 = element.getBaseArgumentToken(0);
						StatementPeer.AssignmentPatternPeer child_5 = indirect_6.createAssignment(variableToken_1.getStringValue());
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersIndentTest.AssignmentDecoder(child_5));
							child_5.end();
						}
					}
				}
				if(type_2 == 1) {
					StatementPeer.Indirect indirect_7 = peer_.getStatementForElseStatements();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						StatementPeer.IfPatternPeer child_6 = indirect_7.createIf(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersIndentTest.IfDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type_2 == 2) {
					StatementPeer.Indirect indirect_8 = peer_.getStatementForElseStatements();
					if(indirect_8 != null) {
						StatementPeer.ExpressionPatternPeer child_7 = indirect_8.createExpression();
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersIndentTest.ExpressionDecoder(child_7));
							child_7.end();
						}
					}
				}
			}
		}
	}
	public static final class ExpressionDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final StatementPeer.ExpressionPatternPeer peer_;
		public ExpressionDecoder(StatementPeer.ExpressionPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					ExpressionPeer.Indirect indirect = peer_.getExpressionForE();
					if(indirect != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
						ExpressionPeer.FunctionPatternPeer child = indirect.createFunction(nameToken.getStringValue());
						if(child != null) {
							element.updateConstruction(new AllDecodersIndentTest.FunctionDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					ExpressionPeer.Indirect indirect_1 = peer_.getExpressionForE();
					if(indirect_1 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(0);
						indirect_1.createVariable(nameToken_1.getStringValue());
					}
				}
				if(type == 2) {
					ExpressionPeer.Indirect indirect_2 = peer_.getExpressionForE();
					if(indirect_2 != null) {
						ExpressionPeer.PrimitivePatternPeer child_1 = indirect_2.createPrimitive();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersIndentTest.PrimitiveDecoder(child_1));
							child_1.end();
						}
					}
				}
			}
		}
	}
}
