package indent.austen.packrat.impl;
import indent.austen.packrat.library.*;
import indent.austen.lexi.tokens.*;
import indent.austen.user.*;
public final class StatementReader implements IndentTestPackrat.BaseReader {
	private final int rULE_INDEX_ = 1;
	private final IndentTestPackrat basePackrat_;
	public StatementReader(IndentTestPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(IndentTestPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = 0;
		result.mark();
		width = decodeAssignmentForStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 0, 1);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeIfForStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 1, 1);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeExpressionForStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 2, 1);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		return null;
	}
	public final int decodeAssignmentForStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, IndentTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		IndentToken token = c.getColumnToken(newOffset);
		if(!token.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		IndentToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isASSIGNMENT_SYMBOL()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 0).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		result.mark();
		int checkOffset = maybeSub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		return newOffset;
	}
	public final int maybeSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, IndentTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		IndentToken token = c.getColumnToken(newOffset);
		if(!token.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int decodeIfForStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, IndentTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		c.indentBaseValue__2_ = 0;
		c.currentIndentValue__3_ = 0;
		IndentTrackerUser baseClass = basePackrat_.trackerValue_;
		int lineInt;
		lineInt = c.getCurrentLineNumber(newOffset);
		c.indentBaseValue__2_ = baseClass.getIndent(lineInt);
		IndentToken token = c.getColumnToken(newOffset);
		if(!token.isIF_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		IndentToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isLEFT_ROUND()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 0).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		IndentToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isRIGHT_ROUND()) {
			return -1;
		}
		newOffset++;
		int checkOffset = newOffset;
		result.mark();
		while(checkOffset >= 0) {
			checkOffset = zeroOrMoreSub(result, c, newOffset);
			if(checkOffset > newOffset) {
				newOffset = checkOffset;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		int checkOffset_1 = newOffset;
		result.mark();
		while(checkOffset_1 >= 0) {
			checkOffset_1 = zeroOrMoreSub_1(result, c, newOffset);
			if(checkOffset_1 > newOffset) {
				newOffset = checkOffset_1;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		result.mark();
		int checkOffset_2 = maybeSub_1(result, c, newOffset);
		if(checkOffset_2 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_2;
			result.removeLastMark();
		}
		return newOffset;
	}
	public final int zeroOrMoreSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, IndentTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		if(c.isNewLine(newOffset)) {
			return -1;
		}
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 1).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		return newOffset;
	}
	public final int zeroOrMoreSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, IndentTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		IndentTrackerUser baseClass = basePackrat_.trackerValue_;
		int lineInt;
		lineInt = c.getCurrentLineNumber(newOffset);
		c.currentIndentValue__3_ = baseClass.getIndent(lineInt);
		boolean passQuery;
		int left;
		int right;
		left = c.indentBaseValue__2_;
		right = c.currentIndentValue__3_;
		passQuery = left < right;
		if(!passQuery) {
			return -1;
		}
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 1).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		return newOffset;
	}
	public final int maybeSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, IndentTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		IndentTrackerUser baseClass = basePackrat_.trackerValue_;
		int lineInt;
		lineInt = c.getCurrentLineNumber(newOffset);
		c.currentIndentValue__3_ = baseClass.getIndent(lineInt);
		boolean passQuery;
		int left;
		int right;
		left = c.indentBaseValue__2_;
		right = c.currentIndentValue__3_;
		passQuery = left == right;
		if(!passQuery) {
			return -1;
		}
		IndentToken token = c.getColumnToken(newOffset);
		if(!token.isELSE_KEYWORD()) {
			return -1;
		}
		newOffset++;
		int checkOffset = newOffset;
		result.mark();
		while(checkOffset >= 0) {
			checkOffset = zeroOrMoreSub_2(result, c, newOffset);
			if(checkOffset > newOffset) {
				newOffset = checkOffset;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		int checkOffset_1 = newOffset;
		result.mark();
		while(checkOffset_1 >= 0) {
			checkOffset_1 = zeroOrMoreSub_3(result, c, newOffset);
			if(checkOffset_1 > newOffset) {
				newOffset = checkOffset_1;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		return newOffset;
	}
	public final int zeroOrMoreSub_2(org.ffd2.austenx.runtime.ResolvedPackratElement result, IndentTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		if(c.isNewLine(newOffset)) {
			return -1;
		}
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 1).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(2, rule);
		return newOffset;
	}
	public final int zeroOrMoreSub_3(org.ffd2.austenx.runtime.ResolvedPackratElement result, IndentTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		IndentTrackerUser baseClass = basePackrat_.trackerValue_;
		int lineInt;
		lineInt = c.getCurrentLineNumber(newOffset);
		c.currentIndentValue__3_ = baseClass.getIndent(lineInt);
		boolean passQuery;
		int left;
		int right;
		left = c.indentBaseValue__2_;
		right = c.currentIndentValue__3_;
		passQuery = left < right;
		if(!passQuery) {
			return -1;
		}
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 1).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(2, rule);
		return newOffset;
	}
	public final int decodeExpressionForStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, IndentTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 0).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		result.mark();
		int checkOffset = maybeSub_2(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		return newOffset;
	}
	public final int maybeSub_2(org.ffd2.austenx.runtime.ResolvedPackratElement result, IndentTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		IndentToken token = c.getColumnToken(newOffset);
		if(!token.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
}
