package indent.austen.packrat.library;
import indent.austen.lexi.tokens.*;
import indent.austen.user.*;
import indent.austen.peg.base.*;
import indent.austen.packrat.impl.*;
public final class IndentTestPackrat {
	private final org.ffd2.solar.general.Source<IndentToken> allTokens_;
	public final IndentTrackerUser trackerValue_;
	public IndentTestPackrat(org.ffd2.solar.general.Source<IndentToken> allTokens, IndentTrackerUser trackerValue) {
		allTokens_ = allTokens;
		trackerValue_ = trackerValue;
	}
	private final IndentTestPackrat.Table createTable() {
		return new IndentTestPackrat.Table(allTokens_, this);
	}
	public static final org.ffd2.austenx.runtime.BuildStats quickAndSimpleBuildFile(org.ffd2.solar.language.CharacterSource fileText, IndentParser parser, FileRootBuilderForIndentTest target, org.ffd2.austenx.runtime.ParserErrorCatcher errorCatcher, IndentTrackerUser trackerValue) {
		return quickBuildFile(fileText, parser, target, errorCatcher, errorCatcher, trackerValue);
	}
	public static final org.ffd2.austenx.runtime.BuildStats quickBuildFile(org.ffd2.solar.language.CharacterSource fileText, IndentParser parser, FileRootBuilderForIndentTest target, org.ffd2.austenx.runtime.LexErrorCatcher lexErrorCatcher, org.ffd2.austenx.runtime.PackratErrorCatcher packratErrorCatcher, IndentTrackerUser trackerValue) {
		org.ffd2.solar.general.SimpleVector<IndentToken> tokens = new org.ffd2.solar.general.SimpleVector<IndentToken>();
		org.ffd2.austenx.runtime.ErrorCatcherTool errorCatcher = new org.ffd2.austenx.runtime.ErrorCatcherTool(lexErrorCatcher, packratErrorCatcher);
		parser.doParse(tokens, fileText, errorCatcher);
		if(!errorCatcher.isInError()) {
			IndentTestPackrat builder = new IndentTestPackrat(tokens, trackerValue);
			return builder.buildFile(target, errorCatcher);
		} else {
			return null;
		}
	}
	public final org.ffd2.austenx.runtime.BuildStats buildFile(FileRootBuilderForIndentTest builder, org.ffd2.austenx.runtime.PackratErrorCatcher errorCatcher) {
		IndentTestPackrat.Table table = createTable();
		org.ffd2.austenx.runtime.PackratElement base = table.getResult(0, 2);
		org.ffd2.austenx.runtime.ResolvedPackratElement resolved = base.getResolved();
		int tableWidth = table.getTableWidth();
		org.ffd2.austenx.runtime.ErrorInfo errorInfo = table.getErrorHintInfo();
		if(resolved == null) {
			if(errorInfo == null) {
				errorCatcher.failedParse(table.getMaximumAccessedToken());
			} else {
				errorCatcher.failedParseWithErrorHint(table.getMaximumAccessedToken(), errorInfo.getMessage());
			}
		} else {
			if(tableWidth != resolved.getWidth()) {
				if(errorInfo == null) {
					errorCatcher.incompleteParse(table.getTableToken(resolved.getWidth() - 1), table.getMaximumAccessedToken());
				} else {
					errorCatcher.incompleteParseWithErrorHint(table.getTableToken(resolved.getWidth() - 1), table.getMaximumAccessedToken(), errorInfo.getMessage());
				}
			} else {
				FilePatternPeer child = builder.buildFile();
				if(child != null) {
					resolved.updateConstruction(new AllDecodersIndentTest.FileDecoder(child));
					child.end();
				}
			}
		}
		return table.buildStats();
	}
	public static final class Table {
		private final org.ffd2.austenx.runtime.ElementTableInterface concreteTable_;
		private final org.ffd2.solar.general.Source<IndentToken> allTokens_;
		private final int numberOfTokens_;
		private final ErrorToken errorToken_;
		private int maximumAccessedTokenIndex_ = 0;
		private java.lang.String maxErrorHint_;
		private int maxErrorTokenIndex_ = 0;
		private final IndentTestPackrat.BaseReader[] readers_;
		private IndentTestPackrat.Column columnPool_ = null;
		private int numberOfColumnObjects_ = 0;
		private final int[] memorisationUseCounts_;
		private int numberOfTableAccesses_ = 0;
		public Table(org.ffd2.solar.general.Source<IndentToken> allTokens, IndentTestPackrat parent) {
			allTokens_ = allTokens;
			errorToken_ = new ErrorToken();
			int numberOfTokens = allTokens.size();
			numberOfTokens_ = numberOfTokens;
			concreteTable_ = new org.ffd2.austenx.runtime.MatrixElementTable(numberOfTokens, 6);
			readers_ = new IndentTestPackrat.BaseReader[6];
			readers_[0] = new ExpressionReader(parent);
			readers_[2] = new FileReader(parent);
			readers_[3] = new ClassReader(parent);
			readers_[4] = new ClassStrictReader(parent);
			readers_[5] = new ClassElementReader(parent);
			readers_[1] = new StatementReader(parent);
			memorisationUseCounts_ = new int[2];
		}
		public final org.ffd2.austenx.runtime.PackratElement getResult(int column, int ruleIndex) {
			numberOfTableAccesses_++;
			if(column >= numberOfTokens_) {
				return org.ffd2.austenx.runtime.ErrorElement.getInstance();
			}
			if(ruleIndex < 2) {
				org.ffd2.austenx.runtime.PackratElement result = concreteTable_.getResult(column, ruleIndex);
				if(result == null) {
					IndentTestPackrat.Column c = allocateColumn(column);
					c.addRule(ruleIndex);
					c.doResolutions();
					result = concreteTable_.getResult(column, ruleIndex);
					deallocateColumn(c);
				} else {
					memorisationUseCounts_[ruleIndex]++;
				}
				return result;
			} else {
				IndentTestPackrat.Column c2 = allocateColumn(column);
				c2.addRule(ruleIndex);
				c2.doResolutions();
				org.ffd2.austenx.runtime.PackratElement result_1 = c2.getResult(0, ruleIndex);
				deallocateColumn(c2);
				return result_1;
			}
		}
		public final int getTableWidth() {
			return numberOfTokens_;
		}
		public final org.ffd2.austenx.runtime.ErrorInfo getErrorHintInfo() {
			return new org.ffd2.austenx.runtime.ErrorInfo(maxErrorHint_, allTokens_.get(maxErrorTokenIndex_), allTokens_.get(maximumAccessedTokenIndex_));
		}
		public final IndentToken getMaximumAccessedToken() {
			return getTableToken(maximumAccessedTokenIndex_);
		}
		public final IndentToken getTableToken(int column) {
			if(column >= numberOfTokens_) {
				return errorToken_;
			} else {
				if(column > maximumAccessedTokenIndex_) {
					maximumAccessedTokenIndex_ = column;
				}
				if(column < 0) {
					return errorToken_;
				}
				return allTokens_.get(column);
			}
		}
		public final org.ffd2.austenx.runtime.BuildStats buildStats() {
			java.lang.String[] allRuleNames = new java.lang.String[6];
			allRuleNames[0] = "Expression";
			allRuleNames[2] = "File";
			allRuleNames[3] = "Class";
			allRuleNames[4] = "ClassStrict";
			allRuleNames[5] = "ClassElement";
			allRuleNames[1] = "Statement";
			return new org.ffd2.austenx.runtime.BuildStats(numberOfTokens_, numberOfColumnObjects_, numberOfTableAccesses_, memorisationUseCounts_, allRuleNames, 2);
		}
		public final void setErrorHint(java.lang.String message, int tokenIndex) {
			if(maxErrorTokenIndex_ <= tokenIndex) {
				maxErrorTokenIndex_ = tokenIndex;
				maxErrorHint_ = message;
			}
		}
		public final void clearError() {
			maxErrorHint_ = null;
			maxErrorTokenIndex_ = 0;
		}
		public final java.lang.String getErrorHint() {
			return maxErrorHint_;
		}
		public final IndentToken getErrorHintToken() {
			return getTableToken(maxErrorTokenIndex_);
		}
		public final IndentToken getTableTokenOrLast(int column) {
			if(column >= numberOfTokens_) {
				return getTableToken(numberOfTokens_ - 1);
			} else {
				if(column < 0) {
					return getTableToken(0);
				} else {
					return getTableToken(column);
				}
			}
		}
		public final boolean isTokenAt(int column) {
			return column >= 0 && column < numberOfTokens_;
		}
		public final org.ffd2.austenx.runtime.PackratElement checkResult(int column, int ruleIndex) {
			return concreteTable_.getResult(column, ruleIndex);
		}
		public final void updateResult(int column, int ruleIndex, org.ffd2.austenx.runtime.PackratElement result) {
			concreteTable_.setResult(column, ruleIndex, result);
		}
		public final IndentTestPackrat.BaseReader getReader(int ruleIndex) {
			return readers_[ruleIndex];
		}
		private final IndentTestPackrat.Column allocateColumn(int column) {
			IndentTestPackrat.Column c;
			if(columnPool_ != null) {
				c = columnPool_;
				columnPool_ = c.getPrevious();
				c.resetColumn(column);
			} else {
				c = new IndentTestPackrat.Column(this, column);
				numberOfColumnObjects_++;
			}
			return c;
		}
		private final void deallocateColumn(IndentTestPackrat.Column c) {
			c.setPrevious(columnPool_);
			columnPool_ = c;
		}
	}
	public static final class Column {
		private final IndentTestPackrat.Table baseTable_;
		private int column_;
		private final org.ffd2.austenx.runtime.PackratElement[] transientResults_;
		private final org.ffd2.solar.general.IntVector resolvingList_;
		private boolean recursiveRequestMade_;
		private IndentTestPackrat.Column previous_ = null;
		public int indentBaseValue_;
		public int currentIndentValue_;
		public int currentIndentValue__1_;
		public int indentBaseValue__1_;
		public int currentIndentValue__2_;
		public int indentBaseValue__2_;
		public int currentIndentValue__3_;
		public Column(IndentTestPackrat.Table baseTable, int column) {
			baseTable_ = baseTable;
			column_ = column;
			transientResults_ = new org.ffd2.austenx.runtime.PackratElement[4];
			resolvingList_ = new org.ffd2.solar.general.IntVector();
			indentBaseValue_ = 0;
			currentIndentValue_ = 0;
			currentIndentValue__1_ = 0;
			indentBaseValue__1_ = 0;
			currentIndentValue__2_ = 0;
			indentBaseValue__2_ = 0;
			currentIndentValue__3_ = 0;
		}
		public final org.ffd2.austenx.runtime.PackratElement getResult(int offset, int ruleIndex) {
			if(offset > 0) {
				return baseTable_.getResult(column_ + offset, ruleIndex);
			} else {
				if(resolvingList_.isContains(ruleIndex)) {
					recursiveRequestMade_ = true;
				} else {
					addRule(ruleIndex);
					rebuildResult(ruleIndex);
				}
				return getDirectCurrentResult(ruleIndex);
			}
		}
		public final int getCurrentLineNumber(int offset) {
			return baseTable_.getTableTokenOrLast(column_ + offset).getLineNumber();
		}
		public final int getCurrentCharacterNumber(int offset) {
			return baseTable_.getTableTokenOrLast(column_ + offset).getCharacterNumber();
		}
		public final java.lang.String getCurrentErrorMessage() {
			org.ffd2.austenx.runtime.ErrorInfo ei = getErrorHintInfo();
			if(ei != null) {
				return ei.getMessage();
			} else {
				return "";
			}
		}
		public final IndentToken getColumnTokenOrLast(int offset) {
			return baseTable_.getTableTokenOrLast(column_ + offset);
		}
		public final org.ffd2.austenx.runtime.ErrorInfo getErrorHintInfo() {
			return baseTable_.getErrorHintInfo();
		}
		public final void clearError() {
			baseTable_.clearError();
		}
		public final IndentToken getColumnToken(int offset) {
			return baseTable_.getTableToken(column_ + offset);
		}
		public final boolean isNewLine(int offset) {
			final int index = column_ + offset;
			if(index == 0) {
				return baseTable_.getTableToken(index).getLineNumber() > 0;
			} else {
				org.ffd2.austenx.runtime.BaseToken token = baseTable_.getTableToken(index);
				return baseTable_.getTableToken(index).getLineNumber() > baseTable_.getTableToken(index - 1).getLineNumber();
			}
		}
		public final boolean isColumnTokenAt(int offset) {
			return baseTable_.isTokenAt(column_ + offset);
		}
		public final void setErrorHint(java.lang.String message, int offset) {
			baseTable_.setErrorHint(message, column_ + offset);
		}
		public final IndentTestPackrat.Column getPrevious() {
			return previous_;
		}
		public final void resetColumn(int newColumn) {
			if(newColumn != column_) {
				column_ = newColumn;
				for(int i = 4 - 1 ; i >= 0 ; i--) {
					transientResults_[i] = null;
				}
			}
			resolvingList_.removeAllElements();
			recursiveRequestMade_ = false;
		}
		public final void setPrevious(IndentTestPackrat.Column c) {
			previous_ = c;
		}
		public final void addRule(int ruleIndex) {
			resolvingList_.addElement(ruleIndex);
			setDirectCurrentResult(ruleIndex, org.ffd2.austenx.runtime.ErrorElement.getInstance());
		}
		public final void doResolutions() {
			while(stackSweep()) {
			}
		}
		private final void setDirectCurrentResult(int ruleIndex, org.ffd2.austenx.runtime.PackratElement resultz) {
			if(ruleIndex < 2) {
				baseTable_.updateResult(column_, ruleIndex, resultz);
			} else {
				transientResults_[ruleIndex - 2] = resultz;
			}
		}
		private final boolean rebuildResult(int ruleIndex) {
			org.ffd2.austenx.runtime.PackratElement oldResult = getDirectCurrentResult(ruleIndex);
			IndentTestPackrat.BaseReader reader = baseTable_.getReader(ruleIndex);
			org.ffd2.austenx.runtime.PackratElement newResult = reader.build(this, oldResult);
			if(newResult != null) {
				setDirectCurrentResult(ruleIndex, newResult);
				return true;
			} else {
				return false;
			}
		}
		private final org.ffd2.austenx.runtime.PackratElement getDirectCurrentResult(int ruleIndex) {
			if(ruleIndex < 2) {
				return baseTable_.checkResult(column_, ruleIndex);
			} else {
				return transientResults_[ruleIndex - 2];
			}
		}
		private final boolean stackSweep() {
			recursiveRequestMade_ = false;
			final int initialSize = resolvingList_.size();
			int current = initialSize;
			boolean betterResolutionMade = false;
			while(current != 0) {
				current--;
				int ruleIndex = resolvingList_.get(current);
				if(rebuildResult(ruleIndex)) {
					betterResolutionMade = true;
				}
			}
			if(recursiveRequestMade_) {
				if(betterResolutionMade) {
					return true;
				}
				return initialSize != resolvingList_.size();
			} else {
				return false;
			}
		}
	}
	public static interface BaseReader {
		public org.ffd2.austenx.runtime.PackratElement build(IndentTestPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldResult) ;
	}
}
